% ESAC DC Stability Shortcourse, September 13-14, 2001
% S.D. Sudhoff
% Example 1

% Step 1: Create the s-vector.
freqmin=0.01;                       % minimum frequency considered
freqmax=10000.0;                    % maximum frequency considered
nfreq=60;                           % number of frequencies considered
s = svec1(freqmin,freqmax,nfreq);   % create the s vector for the Nyquist contour

% Step 2: Parameters of the generalized sets.
NS=8;                               % number of sides to generalized source impedance
NI=1;                               % number of intermediate point to generalized source impedance

% Step 3: Characterize Q-PCM4 (Power Supply)
vpllmin=560.0*0.95;                 % minimum source voltage (l-l,rms)
vpllmax=560.0*1.05;                 % maximum source voltage (l-l,rms)
nv=3;                               % number of voltages to consider
wemin=2*pi*60*0.95;                 % minimum source frequency (rad/s)
wemax=2*pi*60*1.05;                 % maximum source frequency (rad/s)
nwe=3;                              % number of source frequencies to try
llpmin=4.16e-3;                     % minimum transformer leakage inductance (primary side)
llpmax=2.08e-3;                     % maximum transformer leakage inductance (seconary side)
nl=3;                               % number of reactances to try
nps=1.513;                          % turns ratio
ldc=3.5e-3;                         % dc link inductance
rdc=0.33;                           % dc link inductor resistance
cdc=1.5e-3;                         % output capacitance
rcdc=0.0;
kp=0.0;                             % controller proportional gain
ki=0.0;                             % controller integral gain
[PCM4_S] = rectsrce(vpllmin,vpllmax,nv,wemin,wemax,nwe,llpmin,llpmax,nl,nps,ldc,rdc,cdc,rcdc,kp,ki,s,NS,NI);

% Step 4: Plot the generalized source impedance
fignum=1;                           % figure number
plttyp=4;                           % plot type
offset=0.0;                         % phase offset
spaceplt(1,4,s,PCM4_S,0.0);
title('Generalized Source Impedance of QPCM-4');