% ESAC DC Stability Shortcourse, September 13-14, 2001
% S.D. Sudhoff
% Example 1

% Step 1: Create the s-vector.
freqmin=0.01;                       % minimum frequency considered
freqmax=10000.0;                    % maximum frequency considered
nfreq=60;                           % number of frequencies considered
s = svec1(freqmin,freqmax,nfreq);   % create the s vector for the Nyquist contour

% Step 2: Parameters of the generalized sets.
NS=8;                               % number of sides to generalized source impedance
NI=4;                               % number of intermediate point to generalized source impedance

% Step 3: Generalized description of source
vpllmin=560.0*0.95;                 % minimum source voltage (l-l,rms)
vpllmax=560.0*1.05;                 % maximum source voltage (l-l,rms)
nv=3;                               % number of voltages to consider
wemin=2*pi*60*0.95;                 % minimum source frequency (rad/s)
wemax=2*pi*60*1.05;                 % maximum source frequency (rad/s)
nwe=3;                              % number of source frequencies to try
llpmin=4.16e-3;                     % minimum transformer leakage inductance (primary side)
llpmax=2.08e-3;                     % maximum transformer leakage inductance (seconary side)
nl=3;                               % number of reactances to try
nps=1.513;                          % turns ratio
ldc=3.5e-3;                         % dc link inductance
rdc=0.33;                           % dc link inductor resistance
cdc=1.5e-3;                         % output capacitance
rcdc=0.0;                           % ouptut capacitor ESR
kp=0.0;                             % controller proportional gain
ki=0.0;                             % controller integral gain
[PCM4_S] = rectsrce(vpllmin,vpllmax,nv,wemin,wemax,nwe,llpmin,llpmax,nl,nps,ldc,rdc,cdc,rcdc,kp,ki,s,NS,NI);

% Step 4: Plot the generalized source imedance
spaceplt(1,1,s,PCM4_S);
title('Generalized Source Impedance of QPCM-4 (Plot Type =1)');

spaceplt(2,2,s,PCM4_S);
title('Generalized Source Impedance of QPCM-4 (Plot Type =2)');

% set offset for magnitude and phase plots
poffset=0.0;

spaceplt(3,3,s,PCM4_S,poffset);
title('Generalized Source Impedance of QPCM-4 (Plot Type =3)');

spaceplt(4,4,s,PCM4_S,poffset);
title('Generalized Source Impedance of QPCM-4 (Plot Type =4)');

% set breakpoint for hybrid coordinate plots
brkpntdb=-20.0;

spaceplt(5,5,s,PCM4_S,brkpntdb);
title('Generalized Source Impedance of QPCM-4 (Plot Type =5)');

spaceplt(6,6,s,PCM4_S,brkpntdb);
title('Generalized Source Impedance of QPCM-4 (Plot Type =6)');
