% This file is to generate data for example 2

% set up frequency vector
freqmn=0.01;
freqmx=10000;
M=140;
f=logspace(log10(freqmn),log10(freqmx),M);
s=j*2*pi*f';

% input capacitance
Ce=600.0e-6;

% voltage vector
Q=5;
ve0=linspace(390,430,Q);

% power vector
P=10;
Pe0=linspace(0,5e3,P);

% compute the concatenated impedance matrix
for m=1:M,
   for q=1:Q,
      for p=1:P,
          n=p+P*(q-1);
          Y=Ce*s(m)-Pe0(p)/(ve0(q)^2);
          Z(m,n)=1.0/Y;
          Zdata(m,2*n-1)=abs(Z(m,n));
          Zdata(m,2*n)=angle(Z(m,n))*180/pi; 
      end
   end
end

% save data to file
save 'example2data.txt' Zdata -ASCII

% load data from file
load example2data.txt;
[ze] = immdchar(example2data,0,2,8,4);

% plot the data
spaceplt(1,4,s,ze,0.0);
title('Generalized Impedance of Example System');