% This file is to generate data for example 2

% set up frequency vector
s=svec1(0.01,10000,140.0);

% load data from file
load ssimdata.txt;

% set parameters for data
invflag=0;                 % don't invert data
format=2;                  % magnitude and phase; not real and imaginary
NS=8;                      % number of sides used to bound data
NI=4;                      % number of intermediate points to bound data

% turn data file into generalized impedance
[s,SSIM_Measured_Impedance] = immdchar(ssimdata,invflag,format,NS,NI);

% plot the data
spaceplt(1,4,s,SSIM_Measured_Impedance,0.0);
title('Measured Impedance Looking into SSIM');

% turn data file into generalized impedance
invflag=1;                 % turn impedance data into admittance
[s,SSIM_L_meas] = immdchar(ssimdata,invflag,format,NS,NI);

% plot the measured admittance data
spaceplt(2,4,s,SSIM_L_meas,0.0);
title('Measured Admittance Looking into SSIM');

% just for kicks, lets look at equivalent constant power load
c=590e-6;                           % input capacitance
r=0.127;                            % input capacitance series resistance
vmax=420.0;                         % maximum input voltage
vmin=400.0;                         % minimum input voltage
nv=5;                               % number of voltages to use
pmin=0.0;                           % minimum power
pmax=9600;                          % maximum power
np=10;                              % number of powers to use
[SSIM_L_calc] = cpld(c,r,vmin,vmax,nv,pmin,pmax,np,s,NS,NI);

% plot the calculated admittance data
spaceplt(3,4,s,SSIM_L_calc,0.0);
axis([1 4 -100 200 -40 30]);
title('Calculated Admittance Looking into SSIM');
