% example3.m
%
% This script is designed to be called from Matlab, after
% the combined A,B,C,D matrices have been loaded.  This
% script reads them in, and finds and plot the generalized
% impedances.
%
% Written by:
% S.D. Sudhoff
% School of Electrical and Computer Engineering
% 1285 Electrical Engineering Building
% West Lafayette, IN 47907-1285
% Phone: 765-494-3246
% Fax: 765-494-0676
% E-mail: sudhoff@ecn.purdue.edu

% load in abcd matrices
load srcez;

% Determine nyquist contour
s=svec1(0.1,10000,100);

% Determine generalized source impedance
invflag=0;               % don't invert description
NS=4;                    % number of sides to use in boundary
NI=2;                    % number of intermediate points
zs = stspchar1(CA,CB,CC,CD,invflag,s,NS,NI);

% Plot the generalized source impedance
spaceplt(1,4,s,zs,0.0);
title('Generalized Impedance of Synchronous Machine Rectifier Power Supply');