% ESAC DC Stability Toolbox 
% ESAC-IAP Short Course November 2, 2000 - S.D. Sudhoff
% Example 3: linearize_plants.m
%
% This script is designed to be called from ASCL math, after
% the project smrect (synchronous-machine rectifier) is loaded.
% This script linearizes the plants over a range of operating points.
%
% Written by:
% S.D. Sudhoff
% School of Electrical and Computer Engineering
% 1285 Electrical Engineering Building
% West Lafayette, IN 47907-1285
% Phone: 765-494-3246
% Fax: 765-494-0676
% E-mail: sudhoff@ecn.purdue.edu

pbase=3.7e3;                      % base power
Np=5;                             % number of points in power range
vbase=400.0;                      % base dc voltage
Nv=3;                             % number of points in voltage range
wrmbase=253.4;                    % base speed
Nwrm=3;                           % number of points in speed range

wrm=linspace(0.9,1.1,Nwrm)*wrmbase;  % speeds considered
vcom=linspace(0.9,1.1,Nv)*vbase;     % voltages considered
p=linspace(0.1,1.1,Np)*pbase;        % output powers considered

for k=1:Np,
   for l=1:Nv,
      for m=1:Nwrm,
      
         VCOM=vcom(l);              % assign the operating point of interest
         WRMSTAR=wrm(m);
         RLOAD=(VCOM*VCOM)/p(k);
         
         % call acsl and find the jacobian
         !! findz                   
         
         % augment the operating A,B,C,D to the overall A,B,C,C
         order=size(jac,1);
         A1=jac(1:order-1,1:order-1);
         B1=jac(1:order-1,order);
         C1=jac(order,1:order-1);
         D1=jac(order,order);
         if (k==1)&(l==1)&(m==1)
            CA=A1;
            CB=B1;
            CC=C1;
            CD=D1;
         else
            CA=[CA A1];
            CB=[CB B1];
            CC=[CC C1];
            CD=[CD D1];
         end
         
      end
   end   
end

% Save the genarlized A,B,C,D matrices
save @Format=Matlab @File=srcez @Precision=Double CA CB CC CD