"---------------------------------------------------------------------"
"                                                                     "
" Author:      S.D. Sudhoff                                           "
"              Purdue University                                      "
"              School of Electrical and Computer Engineering          "
"              1285 Electrical Engineering Bulding                    "
"              West Lafayette, IN 47906                               "
"              Phone: 765-494-3246                                    "
"              Fax: 765-494-0676                                      "
"              E-mail: sudhoff@ecn.purdue.edu                         "
" Version:     1.0                                                    "
"                                                                     "
"---------------------------------------------------------------------"

s hvdprn=.t.         ! set high volume print to false
s strplt=.t.         ! use strip plots instead of continouos plots
s calplt=.f.
s weditg=.f.
prepare t,vdc1       ! prepare time and dc bus voltage for plotting


! This routine brings the system to steady state and then linearizes it
s maxt=5.0e-4
s ialg=2

proced findz

   analyz /clear               ! get rid of previous settings


   analyz /control=deltai      ! set the control (input) variable to be perturbation in
                               ! load current

   analyz /inc=0.05            ! set the increment to the perturbation
                               ! ACSL does a poor job of this if left to its own devices

   analyz /observe=vdc1        ! set the observable (output variable) to be the dc
                               ! bus voltage

   s k1=1.0                    ! use the nominal resistive load to get the operating point
   s k2=0.0

   s t=0.0                     ! run a study to bring to steady state
   s tstop=5.0                 
   start

   s nrwitg=.t.
   s k1=0.0                    ! now replace the resistive load with a constant
   s k2=1.0                    ! current input load and continue on to let settle out
   s inom=iload                ! a little more
   s t=10.0
   contin
   plot vdc1
   s nrwitg=.f.

   analyz /jacob='jac'         ! now linearize the system and write out the Jacobian

end